concurrent = {{ gitlab_runner_concurrent_jobs }}
check_interval = {{ gitlab_runner_check_interval }}

{% if gitlab_runner_listen_address is defined -%}
listen_address = "{{ gitlab_runner_listen_address }}"
{% endif %}

[session_server]
  session_timeout = 1800

{% for item in gitlab_runners -%}
[[runners]]
  # {{ item.description }}
  # runner_id = {{ (gitlab_runners_register.results[loop.index0].json.id | trim) if gitlab_runners_register.results[loop.index0].json is defined else (gitlab_runner_ids[loop.index0] | trim) }}
  {% if (item.environment_vars is defined) and (item.environment_vars | type_debug == 'list') -%}
    environment = {{ item.environment_vars | to_json }}
  {% endif -%}
  name = "{{ item.name }}"
  limit = {{ item.limit | default(gitlab_runner_limit) }}
  url = "{{ item.gitlab_url }}"
  token = "{{ (gitlab_runners_register.results[loop.index0].json.token | trim) if gitlab_runners_register.results[loop.index0].json is defined else (gitlab_runners_token.results[loop.index0].stdout | trim) }}"
  executor = "{{ item.executor }}"
  [runners.custom_build_dir]
  [runners.cache]
    [runners.cache.s3]
    [runners.cache.gcs]
    [runners.cache.azure]
  [runners.docker]
    tls_verify = true
    image = "{{ item.docker_image | default(gitlab_runner_docker_image) }}"
    {% if (item.extra_hosts is defined or gitlab_runner_extra_hosts is defined) and ((item.extra_hosts | type_debug == 'list') or (gitlab_runner_extra_hosts | type_debug == 'list')) -%}
    extra_hosts = {{ (item.extra_hosts | default(gitlab_runner_extra_hosts)) | to_json }}
    {% endif -%}
    security_opt = {{ item.docker_security_opts | default(gitlab_runner_docker_security_opts) }}
    privileged = {{ item.docker_privileged | default(gitlab_runner_docker_privileged) }}
    disable_entrypoint_overwrite = false
    oom_kill_disable = false
    disable_cache = false
    volumes = ["/cache"{{ ', "' + (item.trusted_certificate_path | default(gitlab_runner_trusted_certificate_path)) + ':/etc/gitlab-runner/certs/ca.crt:ro"' if (item.trusted_certificate_path is defined or gitlab_runner_trusted_certificate_path is defined) else '' }}]
    pull_policy = ["{{ item.docker_pull_policy | default(gitlab_runner_docker_pull_policy) }}"]
    shm_size = 0
  {% if item.executor == 'docker+machine' -%}
  [runners.machine]
    IdleCount = {{ item.machine_idle_count | default(gitlab_runner_machine_idle_count) }}
    IdleScaleFactor = {{ item.machine_idle_scale_factor | default(gitlab_runner_machine_idle_scale_factor) }}
    IdleCountMin = {{ item.machine_idle_count_min | default(gitlab_runner_machine_idle_count_min) }}
    MachineDriver = "{{ item.machine_driver | default(gitlab_runner_machine_driver) }}"
    MachineName = "{{ item.machine_name | default(gitlab_runner_machine_name) }}"
    MaxBuilds = {{ item.max_builds | default(gitlab_runner_max_builds) }}
    MachineOptions = [
      {%- for option, val in (item.machine_options | default(gitlab_runner_machine_options)).items() %}
      "{{ option }}={{ val | join(',') if (val | type_debug == 'list') else val }}",
      {% endfor %}
    ]
    {% if item.autoscale is defined -%}
    {% for policy in item.autoscale -%}
    [[runners.machine.autoscaling]]
      # [second] [minute] [hour] [day of month] [month] [day of week] [year]
      Periods = {{ policy.periods | to_json }}
      IdleCount = {{ policy.idle_count | default('0') }}
      IdleCountMin = {{ policy.idle_count_min | default('0') }}
      IdleScaleFactor = {{ policy.idle_scale_factor | default('0.0') }}
      IdleTime = {{ policy.idle_time | default('600') }}
      Timezone = "{{ policy.tz | default('UTC') }}"
    {% endfor -%}
    {% endif -%}
  {% endif -%}
{% endfor -%}
